#define F_BEEP     0x0004
#define F_WAIT     0x0008
#define F_RESET    0x0010
#define F_FEA66    0x0020
#define F_FEA66R   0x8020
#define F_FEA_CC   0x8000
#define F_ACC      0x0080
#define F_1DEV     0x0100
#define F_HIDDEN   0x0200
#define F_SAVE     0x0400
#define F_EXCLUDE  0x0800
#define F_FILE     0x1000

static  char header0[]=
    "             native        current        capacity    ";

#if defined(NEC_KEISEN)
    static  char header1[]=
        "RDPORTDrTYPEDrDDMODELDNAME[18]DDrDDDDDC/H/SDDDrDDDDDC/H/SDDDrDDDLBADDDrDDMiBDDV";
    static char bottomline[]=
        "ZDDDDDDzDDDDDzDDDDDDDDDDDDDDDDDDzDDDDDDDDDDDDDzDDDDDDDDDDDDDzDD(hex)DDzDDDDDDD^";
    static char atapi_remn[]=
                                        "E             I             E         I       F";
    static char atapi_remn2[]=                        "I             E         I       F";
    static char tate_b[]="F";
    static char tate[]="E";
    static char tate_t[]="I";
#else
    static  char header1[]=
        "+-PORT-+TYPE-+--MODEL-NAME[18]--+-----C/H/S---+-----C/H/S---+---LBA---+--MiB--+";
    static char bottomline[]=
        "+------+-----+------------------+-------------+-------------+--(hex)--+-------+";
    static char atapi_remn[]=
                                        "|             |             |         |       |";
    static char atapi_remn2[]=                        "|             |         |       |";
    static char tate[]="|";
    static char *tate_b=tate;
    static char *tate_t=tate;
#endif
