                TITLE   misc.s
                .186
                .MODEL  small,C
.data
.code
;------------------------------------------------------
;       CheckMachine    machine     return value 0:OK  1:Not
;------------------------------------------------------
CheckMachine    PROC   near
                mov     ah,00
                mov     cx,0FFFFh       ; 悭mꂽ98/AT`FbN
                int     1Ah
                xor     ax,ax
                cmp     cx,0FFFFh
                jE      @f
                not     ax
        @@:
                ret
CheckMachine    ENDP

;------------------------------------------------------
;       CheckH98    H98   return value 0:OK  1:Not
;------------------------------------------------------
CheckH98        PROC   near
                push    es
                xor     ax,ax   ; ax=0
                mov     es,ax
                test    byte ptr es:[0458h],80h  ; bit 7
                jz      NotH98    
                not     ax      ; H98̂Ƃ -1
NotH98:         pop     es
                ret
CheckH98        ENDP
;------------------------------------------------------
;       CheckCPU386     ȈՂCPU386
;------------------------------------------------------
CheckCPU386     PROC   near;  ϐ CPUtype  x=0..6
                mov     bx,0
                mov     es,bx
                mov     bx,0486h
                mov     dx,es:[bx]

                pushf
                pop     ax
                pushf
                or      ax,4000h
                push    ax
                popf
                pushf
                pop     ax
                popf
                and     ax,0C000h
                cmp     ax,4000h        
                jNe     Not386
                ;or      MacEnvFlag, Bit386
                cmp     dx,0            ; 
                jne     @f              ; 
                ;mov     es:[bx],0300h   ; forced 386
        @@:     mov     ax,es:[bx]
                ;mov     CPUtype,AH
.386
                in      ax,5Eh
                shl     eax,16
                in      ax,5Ch
                cmp     eax,0FFFFFFFFh
.186
                je      WrongMachine
                clc
                mov     ax,0
                ret
Not386:         
                pushf
                pop     ax
                test    ax,8000h
                jnz     Not286
                mov     ax,0200h
                ;mov     CPUtype,ah
                ;mov     es:[bx],ax
                mov     ax,2
                stc
                ret
Not286:         mov     ax,0100h
                DB      0D5h,00h        ; AAD 00(V30)    AAD(intel)
                jz      NotV30          ; AL=0          AL=0Ah
                mov     ax,0100h        ; V30 ̒l 0100h Ƃ
                ;mov     CPUtype,ah
                ;mov     es:[bx],ax      
NotV30:
WrongMachine:
                mov     ax,1
                stc
                ret
CheckCPU386     ENDP


;---------------------------------------------
;       GetCmdLine
;---------------------------------------------
                PUBLIC  GetCmdLine
GetCmdLine      PROC  near      BufString:WORD
                push    si
                push    di
                push    ds
                mov     dx,0D20h    ; SPACE  CȒf
                push    ds
                pop     es      ; ES= data segment
                mov     ah,62h  ; get PSP segment.
                int     21h
                mov     ds,bx   ; DS=PSP segment
                mov     si,81h
itera:          lodsb                           
                cmp     al,dl   ;Scan SPACE.
                je      itera
                dec     si
                mov     cx,0
                mov     di,BufString
          @@:   lodsb
                cmp     al,dh   ;Copy while not CarrideReturn code.
                je      ExitCopyCmdLine
                stosb
                inc     cx
                jmp     @b
ExitCopyCmdLine:
                mov     al,0    ; ASCIIZ end of string null.
                stosb
                mov     ax,cx   ; return with character length (excluding NULL).
                pop     ds
                pop     di
                pop     si
                ret     
GetCmdLine      ENDP
                
;--------------------------------------------------------------------------
                PUBLIC  putcc
putcc           PROC   near     color_attr:WORD
                pushf
                push    ax
                push    bx
                push    cx
                push    dx
                mov     DX, color_attr; PC98Agr[gZbg
                mov     dh,0
                mov     cl,10h
                mov     ah,02h
                int 0DCh
                pop     dx
                pop     cx
                pop     bx
                pop     ax
                popf
                ret
putcc           ENDP

;-------------------------------
                PUBLIC  BeepEntry
BeepEntry       PROC   near
                mov     DX,03FDBh        ; 3FDB
                out     DX,AL
                xchg    AL,AH
                out     DX,AL
                mov     al,6
                out     37h,al
          @@:   out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b 
                mov     al,7
                out     37h,al
                mov     cx,0333h
          @@:   out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b 
                mov     ax,04CDh
                mov     DX,03FDBh        ; 3FDB
                out     DX,AL
                xchg    AL,AH
                out     DX,AL
                ret
BeepEntry       ENDP
;-------------------------------
                PUBLIC  LowBeep
LowBeep         PROC   near
                push    ax
                push    cx
                push    dx
                mov     cx,3777h
                or      ax,ax
                jz      correct_tone
                cmp     ax,20000
                ja      correct_tone
                cmp     ax,40
                jb      correct_tone
                jmp     @f
correct_tone:   mov     ax,5555h
        @@:     call    BeepEntry
                pop     dx
                pop     cx
                pop     ax
                ret
LowBeep         ENDP
;-------------------------------
                PUBLIC  Click
Click           PROC   near
                push    ax
                push    cx
                push    dx
                mov     cx,0177h
                mov     ax,1229
                call    BeepEntry
                pop     dx
                pop     cx
                pop     ax
                ret
Click           ENDP

;------------------------------------------
;       SavetoFile ( filename )
;------------------------------------------
                PUBLIC  SavetoFile      
SavetoFile      PROC   near     filenameP:WORD, IdentifyBuf4:WORD, buf4:WORD
                xor     bx,bx
                mov     dx,filenameP
                mov     cx,0020h
                mov     ax,3C00h
                int 21h
                jc      CreateFail1
                mov     bx,ax
                push    bx
                mov     dx,IdentifyBuf4
                mov     cx,512*4
                mov     ax,4000h
                int 21h
                mov     dx,buf4
                mov     cx,4
                mov     ax,4000h
                int 21h

                pop     bx
                jc      CreateFail1
                mov     bx,ax
                mov     ah,3Eh
                int 21h
                xor     ax,ax
                ret
CreateFail1:    mov     ax,1
                ret
SavetoFile      ENDP

;-------------------------------------------
; bŎg֐F o
;-------------------------------------------
                PUBLIC  GetString
GetString       PROC   near     idb:WORD, devno:WORD , wordval:WORD, strlen:WORD, strbuf:WORD
                push    si
                push    di
                push    ds
                pop     es
                mov     si,idb
                mov     ax,devno
                mov     bx,wordval
                shl     bx,1
                mov     cx,200h
                mul     cx
                add     ax,bx
                add     si,ax
                mov     di,strbuf
                mov     cx,strlen
                mov     ax,cx
        rep     movsb
                pop     di
                pop     si
                ret
GetString       ENDP

;-------------------------------------------
; bŎg֐F[h̒l̎o
;-------------------------------------------
                PUBLIC  GetWord
GetWord         PROC   near    idb:WORD, devno:WORD, wordval:WORD
                push    si
                mov     si,idb
                mov     ax,devno
                mov     bx,wordval
                shl     bx,1
                mov     cx,200h
                mul     cx
                add     ax,si
                add     bx,ax

                mov     ax,[bx]
                xchg    al,ah
                pop     si
                ret
GetWord         ENDP

.386
;-------------------------------------------
; bŎg֐F_u[h̒l̎o
;-------------------------------------------
                PUBLIC  GetDword
GetDword        PROC   near    idb:WORD, devno:WORD, wordval:WORD
                push    si
                mov     si,idb
                mov     ax,devno
                mov     bx,wordval
                shl     bx,1
                mov     cx,200h
                mul     cx
                add     ax,si
                add     bx,ax
                
                mov     eax,[bx]
                xchg    al,ah
                rol     eax,16
                xchg    al,ah
                mov     dx,ax
                ror     eax,16
                pop     si
                ret
GetDword        ENDP


;----------------------------------------------------------------------
; bŎg֐FhCu^Cv̒l̎o
;----------------------------------------------------------------------
                PUBLIC  DevType
DevType         PROC   near    idb:WORD,  devno:WORD
                push    es
                push    si

                push    ds      ; ds=es
                pop     es

                mov     si,idb
                mov     ax,devno
                mov     cx,200h
                mul     cx
                add     si,ax
; HDD( IDE/SATA/CF )
                mov     ax,[si]
                mov     dx,ax
                test    ax,1000000010000000b
                jnz     is_rmv
;is_hdd:
                mov     ax,[si+76*2]  ; WORD 76  bit 123
                xchg    al,ah
                test    ax,0000000000001110b
                jnz     is_sata
                test    dx,0000000001000000b
                jz      is_unknown
                mov     ax,1
                jmp     end_devtype
is_rmv:         mov     ax,2
                jmp     end_devtype
is_sata:        
                mov     ax,3
                test    dx,0000000001000000b
                jz      @f
                mov     ax,7
        @@:
                jmp     end_devtype
is_unknown:     mov     ax,0
end_devtype:
                pop     si
                pop     es
                ret
DevType         ENDP


END

