;----------------------------------------------------------------------------
;  ATA identify routine for C program (NEW) 3.01A0  Copyright(C) 2023 DOSsoft
;----------------------------------------------------------------------------
                TITLE   ata350.s
                .186
                .MODEL  small,C
.data
                PUBLIC  IDbuf,Status2
IDbuf           DW      256 dup(?)    ; b\[Xƍ킹
Status2         DW      ?

.code
EXTERN          Click:NEAR
EXTERN          LowBeep:NEAR
include    atadef.inc
Saved0432h      DB      00h     ; ݂Pri/Sec 0432h̕ۑ equ D800:[2079h] ;
Intr0432h       DB      00h     ; intr Pri/Sec 0432h̕ۑ
DevHeadReg      DB      00h
;============================================= 386Kv ========
SelectPortIDE   PROC   near
                mov     al,80h          ; eXĝ߂̓ǂݏo
                mov     dx,0432h
                out     dx,al   
                in      al,dx           ; ǂݏo݂̒l
                mov     cs:Saved0432h,al   ; ۑĂ
                mov     al,BL           ; 0  1  2  3
                shr     al,1            ; 0  0  1  1 =AL
                mov     dx,0432h
                out     dx,al
                mov     ax,bx           ; 000000 000001 000010 000011
                shl     ax,4            ; 000000 010000 100000 110000
                and     al,00010000b    ; (10h) SDH clear except DEV bit
                mov     cs:DevHeadReg,al
                or      al,0A0h         ; A0=CHS, E0=LBA
                ret
SelectPortIDE   ENDP

ExitPortIDE     PROC   near
                mov     ax,bx
                shl     ax,4            ; 000000 010000 100000 110000
                and     al,00010000b    ; (10h) SDH clear except DEV bit
                jz      @f
                mov     al,0A0h         ; A0=CHS,0b=master
                mov     dx,IDEreg_SDHead        ; 064Ch
                out     dx,al
                out     5Fh,al
        @@:
                mov     al,cs:Saved0432h  ; I0432h̒l߂
                mov     dx,0432h
                out     dx,al          ; 
                ret     ; ̃foCXւ̃R}h҂
ExitPortIDE     ENDP

;--------------------------------------------------------
                PUBLIC  Set66h
Set66h          PROC   near     DevNo:WORD,  dflag:WORD
                xor     ax,ax
                mov     Status2,ax
                mov     bx,DevNo        ; ~ |[g̔ԍ 
                CLI
                call    SelectPortIDE
                mov     dx,IDEreg_SDHead        ; 064Ch
                out     dx,al
                out     5Fh,al
                mov     ax,0066h        ; sub command 66
                test    dflag,1
                jz      @f
                mov     ax,00CCh        ; sub command CC
        @@:     call    SetFeatures
                STI
                call    ExitPortIDE
                mov     ax,41
                call    LowBeep
                ret
Set66h          ENDP
;--------------------------------------------------------
                PUBLIC  ResetATA
ResetATA        PROC   near     DevNo:WORD
                mov     bx,DevNo        ; ~ |[g̔ԍ 
                CLI
                call    SelectPortIDE
                mov     dx,IDEreg_SDHead        ; 064Ch
                out     dx,al
                out     5Fh,al

                mov     al,cs:DevHeadReg
                shr     al,3
                or      al,04h
                mov     dx,074Ch
                out     dx,al
                out     5Fh,al
                out     5Fh,al
                mov     ax,4444
                call    LowBeep
                mov     al,00h
                mov     dx,074Ch
                out     dx,al
                out     5Fh,al
                out     5Fh,al
                STI
                mov     cx,3333
   @@:          out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                call    ExitPortIDE
                ret
ResetATA        ENDP

;--------------------------------------------------------
                PUBLIC  IDEinfo
IDEinfo         PROC   near   DevNo:WORD,  CmdCode:WORD
                push    si
                push    di
                xor     ax,ax
                mov     es,ax
                mov     Status2,ax
                mov     bx,DevNo        ; ~ |[g̔ԍ 

                CLI
                call    SelectPortIDE
                mov     dx,IDEreg_SDHead        ; 064Ch
                out     dx,al
                out     5Fh,al

                mov     ax,CmdCode      ; 0/1 =Identify command ECh/A1h
                test    ax,F_ATAPI      ; 000000001b
                mov     al,0ECh
                jz      @f
                mov     al,0A1h
        @@:
                mov     dx,IDEreg_Command       ; 064Eh
                out     dx,al
                out     5Fh,al
                STI

                mov     dx,005Fh
                mov     cx,3333h
        @@:     mov     al,6
                out     dx,al
                mov     al,7
                out     dx,al
               loop     @b

                mov     cx,0FFFEh
        @@:     dec     cx
                or      cx,cx
                jz      DeviceReady
                mov     dx,IDEreg_Status; (064Eh)
                in      al,dx
                test    al,1
                jnz     @b
DeviceReady:
                mov     ax,CmdCode
                test    ax,F_BEEP
                jz      @f
                call    Click
        @@:
                call    Read256Words    ; 256[h̓ǂݏo

                mov     dx,IDEreg_Error; (0642h)
                in      al,dx
                mov     ah,al
                mov     dx,IDEreg_Status; (064Eh)
                in      al,dx
                and     al,0F9h
                mov     Status2,ax
                cmp     al,050h
                je      IdentifyDeviceEnd
                mov     cx,0FFFEh
        @@:     out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                mov     dx,IDEreg_Status; (064Eh)
                in      al,dx
;;;;;;;;;;;;;   and     ah,00000000b
                mov     Status2,ax
                test    al,1
                jz      IdentifyDeviceEnd

IdentifyDeviceEnd:
                mov     ax,bx
                shl     ax,4            ; 000000 010000 100000 110000
                and     al,00010000b    ; (10h) SDH clear except DEV bit
                jz      @f
                mov     al,0A0h         ; A0=CHS,0b=master
                mov     dx,IDEreg_SDHead        ; 064Ch
                out     dx,al
                out     5Fh,al
        @@:
IDEinfo_cancel:
                mov     al,cs:Saved0432h  ; I0432h̒l߂
                mov     dx,0432h
                out     dx,al          ; 
                ; ̃foCXւ̃R}h҂
if 1
                mov     cx,07777h
        @@:     out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
endif
                pop     di
                pop     si
                ret
IDEinfo         ENDP
;---------------------------------------BXSIWX^ύXs
;       SetFeatures      in al=Sub command , ah=0 or sub param
;-------------------------------------------------------------
SetFeatures     PROC   near
                mov     dx,IDEreg_Feature
                out     dx,al
                out     5Fh,al

                or      ah,ah
                jz      @f
                mov     dx,IDEreg_SCount 
                mov     al,ah
                out     dx,al
                out     5Fh,al
        @@:
                mov     dx,IDEreg_Command
                mov     al,0EFh ; The command # of SetFeatures
                out     dx,al
                out     5Fh,al
                mov     cx,3333h
WaitSetFEA:
                out     5Fh,al
                mov     dx,IDEreg_Status
                in      al,dx
                cmp     al,50h
                je      @f
               loop     WaitSetFEA
        @@:
                ret
SetFeatures     ENDP

;---------------------------------------BXSIWX^ύXs


;-------------------------------------------------------
Read256Words    PROC   near     ; 256[h̓ǂݏo Identify
                push    es
                push    ds
                pop     es
                mov     cx,256
                mov     di,offset IDbuf
                mov     dx,IDEreg_Data  ; 0640h
        @@:     in      ax,dx
                xchg    al,ah
                stosw
               loop     @b
                pop     es
                ret
Read256Words    ENDP
;--------------------------------------------------------------

;-------------------------------------------
; bŎg֐FIDE I/O 0430h bit 6
;-------------------------------------------
                PUBLIC  TestPortIDE
TestPortIDE     PROC   near
                mov     dx,0430h
                in      al,dx
                cmp     al,0FFh
                je      IDE1machine
                test    al,40h
                jnz     IDE4machine
                jmp     IDE2machine
IDE4machine:    mov     ax,4
                ret
IDE2machine:    mov     ax,2
                ret
IDE1machine:    mov     ax,1
                ret
TestPortIDE     ENDP

;----------------------------------
;       DeviceFault     
;----------------------------------
                PUBLIC  DeviceFault
DeviceFault     PROC   near
                xor     ax,ax
                mov     dx,0433h
                in      al,dx
                cmp     al,0FFh
                jne     @f
                mov     al,0
        @@:
                ret
DeviceFault     ENDP

END
